program Bonds;

{LIO'99 uzdevums par Bondu.
 Jsasina ifrogramma ldz taj nav "slikto" fragmentu.

  1999, Mrti Opmanis}

const
 atvel_max = 1000;
 nil_pazime = 65535;

type
  adrese = record p1:word; p2:byte; end;

   zars = record
           cipars : char;
           dzilak : adrese;
           talak  : adrese;
          end;

  pkumoss = ^kumoss;
  kumoss = array [0..1] of zars;

var

 adresu_lauks : array [0..atvel_max] of pkumoss;
 atvelets : word;
 aizpildits : array [0..atvel_max] of byte;

 sakums, kur_esi : adrese;
 f_dat, f_rez : Text;
 i, n, l, i_sak, i_bei, i_sliktie : word;
 s , s_jam : string;
 jamaina : boolean;
 kopskaits, neej_ind : longint;

procedure Iespraud(var kur:adrese; ko:string);
var jauns, kur_vecais, kur_ : adrese;
    j : byte;

 begin

  if ko='' then begin kur.p1 := nil_pazime; Exit; end;

  if kur.p1=nil_pazime
   then
    begin

     {Dabsim jaunu vietu}
     jauns.p1 := atvelets;
     jauns.p2 := aizpildits[atvelets];
     if aizpildits[atvelets]=255
      then
       begin
        Inc(atvelets);
        if atvelets>atvel_max then Halt;
        GetMem(adresu_lauks[atvelets],256*sizeof(zars));
        aizpildits[atvelets] := 0;
       end
      else
        Inc(aizpildits[atvelets]);


     kur := jauns;
     adresu_lauks[kur.p1]^[kur.p2].cipars := ko[1];
     adresu_lauks[kur.p1]^[kur.p2].dzilak.p1 := nil_pazime;
     adresu_lauks[kur.p1]^[kur.p2].talak.p1 := nil_pazime;
     Iespraud(adresu_lauks[kur.p1]^[kur.p2].dzilak,Copy(ko,2,10));
    end
   else
    begin

     kur_ := kur;

     {Paskatsimies, vai aj lmen  vrtba jau nav}
     while (kur_.p1<>nil_pazime) and (adresu_lauks[kur_.p1]^[kur_.p2].cipars<>ko[1]) do
      begin
       kur_vecais := kur_;
       kur_ := adresu_lauks[kur_.p1]^[kur_.p2].talak;
      end;
     if kur_.p1=nil_pazime {sasniegtas lmea beigas}
      then
       begin
        {Dabsim jaunu vietu}
     jauns.p1 := atvelets;
     jauns.p2 := aizpildits[atvelets];
     if aizpildits[atvelets]=255
      then
       begin
        Inc(atvelets);
        if atvelets>atvel_max then Halt;
        GetMem(adresu_lauks[atvelets],256*sizeof(zars));
        aizpildits[atvelets] := 0;
       end
      else
        Inc(aizpildits[atvelets]);


     adresu_lauks[jauns.p1]^[jauns.p2].cipars := ko[1];
     adresu_lauks[jauns.p1]^[jauns.p2].dzilak.p1 := nil_pazime;
     adresu_lauks[jauns.p1]^[jauns.p2].talak.p1 := nil_pazime;
     adresu_lauks[kur_vecais.p1]^[kur_vecais.p2].talak := jauns;
     Iespraud(adresu_lauks[jauns.p1]^[jauns.p2].dzilak,Copy(ko,2,10));

       end
      else  {Atrads jau tds cipars priek}
       begin
       if adresu_lauks[kur_.p1]^[kur_.p2].dzilak.p1 <> nil_pazime
        then Iespraud(adresu_lauks[kur_.p1]^[kur_.p2].dzilak,Copy(ko,2,10))
        else
          Exit; {Tlk iet nav jgas, jo bija ska s apakvirkne}
       end;
    end;

 end;


function Atrasts(var kur:adrese;simb:char):boolean;
 begin
  Atrasts := false;
  if kur.p1=nil_pazime then Exit;
  while kur.p1<>nil_pazime do
   begin
    if adresu_lauks[kur.p1]^[kur.p2].cipars = simb
     then
      begin
       kur := adresu_lauks[kur.p1]^[kur.p2].dzilak;
       if kur.p1=nil_pazime then Atrasts := true;
       Exit;
      end
     else
      kur := adresu_lauks[kur.p1]^[kur.p2].talak;
   end;
 end;

begin
 GetMem(adresu_lauks[0],256*sizeof(zars));

 atvelets := 0;
 aizpildits[0] := 0;

 sakums.p1 := nil_pazime;
 kopskaits := 0;
 neej_ind := 0;

 {Ielasa bstams virknes}
 Assign(f_dat,'sliktie.dat');
 Reset(f_dat);
 Readln(f_dat,n);

 for i_sliktie:=1 to n do
  begin
   Readln(f_dat,s);
   Iespraud(sakums,s);
  end;

 Close(f_dat);

 {Ielasa ifrogrammas tekstu}
 Assign(f_dat,'bonds.dat'); Reset(f_dat); Readln(f_dat,s); Close(f_dat);

  {Prbaudam bstamo virku esambu aj string}
  jamaina := true;
  while jamaina do {Cikls, kur maina, kamr ir ko maint}
   begin
    jamaina := false;

    l := Length(s);
    i_sak := 0;
    while (i_sak<l) and (not jamaina) do {Cikls pa dadiem skaita skumiem}
     begin
      kur_esi := sakums;
      Inc(i_sak);
      i_bei := i_sak;
      while (i_bei<=l) and (not jamaina) do {Cikls pa cipariem uz prieku}
       begin
        if Atrasts(kur_esi,s[i_bei])
         then {cipars bija, beidzs ar nil}
          jamaina := true
         else
          if kur_esi.p1=nil_pazime
           then {Tds cipars aj lmen nav}
            break
           else {tacia jau iestaigta - paiesimies pa to}
            Inc(i_bei);
        end;
     end;
    if jamaina
     then  {Jnosvtro pirmais un pdjais simbols bstamaj virkn}
      begin
       s_jam := Copy(s,i_sak+1,i_bei-i_sak-1);
       s := Copy(s,1,i_sak-1)+s_jam+Copy(s,i_bei+1,251);
     end;
   end;

  Assign(f_rez,'bonds.rez'); Rewrite(f_rez); writeln(f_rez,s); Close(f_rez);

  for i:=0 to atvelets do FreeMem(adresu_lauks[i],256*sizeof(zars));

end.